;                      8.1
;       楤  ࠡ  ன⢠ USB
;
;  ⥪ ணࠬ 㫠  쥢.
;  list8_01.inc, 17.06.2002.

DATASEG
; ਧ ᯥ譮 襭 ᪠
SearchResult  DB 0
;  -஫
USB_HostIndex DW 0
;   USB
; न ன⢠ PCI
USB_BusNum    DB ? ; 設
USB_DevNum    DB ? ; ன⢠   㭪樨
; 䨪 ன⢠ PCI
USB_VendorID  DW ? ;䨪 ⮢⥫
USB_DeviceID  DW ? ;䨪 ன⢠
;   ॣ஢ ஫ PCI USB
USB_BaseAddr  DW ?
;  ᯮ㥬 뢠 IRQ
USB_IntLine   DB ? 
; 饭  訡
BadRg DB LIGHTRED,12,28,"  ॣ",0
NoPCI DB 12,24,"⥬  ন PCI BIOS",0
NoUSB DB 12,28,"஫ USB  ",0
NoDev DB 12,26,"ன⢮ USB  㦥",0
TmOut DB 12,21,"ॢ襭 ⨬ ࢠ ",0
BfErr DB 12,28,"  ९",0
DsErr DB 12,25,"᮪ ਯ஢ ९",0
;  
;  ᯮ㥬 ன⢮  USB
USB_PortNum DB ?
;  ॣ ﭨ ᯮ㥬 
USB_PortReg DW 0
;  ன⢠:
; 0 - ᪮⭮, 1 - ᪮⭮
USB_Device_Type   DB 0  
;  ன⢠  設 USB
USB_Device_Number DB 0  
;  筮 窨
USB_EnpointNumber DB 0  
;    
;    7 ࠧ冷  㭪樨
ShFuncNum  DD ?
;    15 ࠧ冷  筮 窨
ShEndpNum  DD ?
;    26 ࠧ冷 ⨯ ன⢠
ShDevType  DD ?
;    21 ࠧ 
ShPackSize DD ?
;     USB
;    ᯨ᪠ ਯ஢
Addr_QH           DD ?
;   ᨢ ਯ஢ ।
Addr_TD_Array     DD ?
;   ਯ 
Addr_CommandDescr DD ?
;    
Addr_DataDescr    DD ?
;  
;     砫 ࠭樨
StartFrame    DW ?
; ﭨ ਣ 
DataTrigger   DD ?
; ꥬ   । ᨢ
BULK_DataSize DW 0
;  
DataBuffer DB 4096 DUP(0ffh) 
ENDS

CODESEG
;****************************************************
;*       - USB        *
;*                              *
;* ணࠬ 믮  -஫஢   *
;* USB, 祭  設 PCI.                    *
;* 室 ࠬ:                               *
;* USB_HostIndex -  -஫.         *
;*  砥 ᯥ譮 襭 樨 ᪠    *
;* ࠬ ஫ ࠭     *
;* ६ USB_BusNum, USB_DevNum, USB_VendorID, *
;* USB_DeviceID, USB_BaseAddr  USB_IntLine.        *
;****************************************************
PROC FindUSBController near
        pushad
;   USB-஫   
        mov     AX,0B103h
        mov     ECX,0C0300h
        mov     SI,[USB_HostIndex]
        int     1Ah
        jnc     @@ReadPCIRegisters ;ன⢮ 
; 室: ஫ USB  
        mov     [SearchResult],1
        popad
        ret
; ன⢮ 㦥,  न  設 PCI
; 室  ॣ BX
@@ReadPCIRegisters:
;  न ஫
        mov     [USB_BusNum],BH
        mov     [USB_DevNum],BL
;  䨪 ⮢⥫
        mov     AX,0B109h ; ᫮
        mov     DI,0      ;ᬥ饭 ᫮
        int     1Ah
        jc      @@BadRegisterNumber
        mov     [USB_VendorID],CX
;  䨪 ன⢠
        mov     AX,0B109h ; ᫮
        mov     DI,2      ;ᬥ饭 ᫮
        int     1Ah
        jc      @@BadRegisterNumber
        mov     [USB_DeviceID],CX
;     ॣ஢ ஫ USB
        mov     AX,0B10Ah ;  ᫮
        mov     DI,20h    ;ᬥ饭 ᫮
        int     1Ah
        jc      @@BadRegisterNumber
        ; 㫨 5  ⮢
        and     CX,0FFE0h
        ; ࠭ ⮫쪮 襥 ᫮ 
        mov     [USB_BaseAddr],CX
;   ᯮ㥬 ன⢮
; 뢠 IRQ
        mov     AX,0B108h ; 
        mov     DI,3Ch    ;ᬥ饭 
        int     1Ah
        jc      @@BadRegisterNumber
        mov     [USB_IntLine],CL
; 室: ஫ , 㢥 祭 
        inc     [USB_HostIndex]
        popad
        ret
;  
;   ॣ
@@BadRegisterNumber:
        MFatalError BadRg
ENDP FindUSBController

;*******************************************
;*       *
;*******************************************
PROC Wait05s near
        push    ES
        push    EAX
        mov     AX,0
        mov     ES,AX
        mov     EAX,[ES:046Ch]
        inc     EAX
@@Wait: cmp     EAX,[ES:046Ch]
        jae     @@Wait
        pop     EAX
        pop     ES
        ret
ENDP Wait05s

;************************************
;*   USB *
;************************************
PROC InitializeDeascriptors near
        pushad
;  1  
        mov     EBX,FrameListBaseAddr
        mov     ECX,100000h/4
        xor     EAX,EAX
@@ClearMemory:
        mov     [GS:EBX],EAX
        add     EBX,4
        dec     ECX
        jnz     @@ClearMemory

;       USB
        ; ᫨    
        xor     EAX,EAX
        xor     EBX,EBX
        mov     AX,DS
        shl     EAX,4
        mov     BX,offset DataBuffer
        add     EAX,EBX
        mov     [Addr_DataDescr],EAX
        ; ᫨   ᥣ ਯ஢
        xor     EAX,EAX
        mov     AX,USB_DESCR
        shl     EAX,4
        mov     EDX,EAX    ;  ᥣ
        ; ᫨    ᯨ᪠
        xor     EBX,EBX
        mov     BX,offset QH_Descriptor
        add     EAX,EBX
        mov     [Addr_QH],EAX
        ; ᫨   ᨢ ਯ஢
        mov     EAX,EDX
        mov     BX,offset TD_Array
        add     EAX,EBX
        mov     [Addr_TD_Array],EAX
; ந 㪠⥫ ஢   ।
        mov     EBX,FrameListBaseAddr
        mov     EAX,[Addr_QH]
        or      EAX,10b                ; T=0, Q=1
        mov     CX,1024
@@ActivateNextFrame:
        mov     [GS:EBX],EAX
        add     EBX,4
        loop    @@ActivateNextFrame
        popad
        ret
ENDP InitializeDeascriptors

;*******************************************************
;*            USB       *
;* । ࠬ:                             *
;* SI - ᬥ饭 ਯ   ᥣ .*
;*******************************************************
PROC StatusIN_Transaction near
        pushad
;   DX ꥬ । 
        mov     DX,[SI+6]
; ᫨    ਯ 
        xor     EAX,EAX
        mov     AX,DS
        shl     EAX,4
        and     ESI,0FFFFh
        add     EAX,ESI
        mov     [Addr_CommandDescr],EAX
; 㧨  ESI 㪠⥫  ᨢ ਯ஢
        mov     ESI,[Addr_TD_Array]
; ନ஢ ਯ 
        ; ⥫  ᫥騩 TD
        mov     EAX,ESI
        add     EAX,32
        mov     [GS:ESI],EAX
        ;  ࠢ
        mov     EAX,[ShDevType] ;⨯ ன⢠
        or      EAX,00800000h   ;ਧ ⨢
        mov     [GS:ESI+4],EAX
        ; થ
        mov     EAX,[ShFuncNum] ; 㭪樨
        or      EAX,00E0002Dh   ;। 8 
        mov     [GS:ESI+8],EAX
        ; ⥫  ਯ 
        mov     EAX,[Addr_CommandDescr]
        mov     [GS:ESI+12],EAX
        xor     EAX,EAX
        mov     [GS:ESI+16],EAX
        mov     [GS:ESI+20],EAX
        mov     [GS:ESI+24],EAX
        mov     [GS:ESI+28],EAX
        add     ESI,32

; ᫨ ⢮ 8- 
;  ࠧ ᫥  
        mov     CX,DX
        shr     CX,3       ;⢮ 8- 
        cmp     CX,64-3
        ja      @@TD_Array_Error
        and     EDX,111b   ;ࠧ ᫥ 
        mov     EBX,[Addr_DataDescr]
        mov     EDI,80000h ;ਣ 
        cmp     CX,0
        je      @@ShortDataBlock
@@NextDataBlock:
; ନ஢ ਯ 
        ; ⥫  ᫥騩 TD
        mov     EAX,ESI
        add     EAX,32
        mov     [GS:ESI],EAX
        ;  ࠢ
        mov     EAX,[ShDevType] ;⨯ ன⢠
        or      EAX,00800000h   ;ਧ ⨢
        mov     [GS:ESI+4],EAX
        ; થ
        mov     EAX,[ShFuncNum] ; 㭪樨
        or      EAX,00E00069h   ;ਭ 8 
        or      EAX,EDI         ;ਣ 
        mov     [GS:ESI+8],EAX
        xor     EDI,80000h      ;४ ਣ
        mov     [GS:ESI+12],EBX ; 
        add     EBX,8
        xor     EAX,EAX
        mov     [GS:ESI+16],EAX
        mov     [GS:ESI+20],EAX
        mov     [GS:ESI+24],EAX
        mov     [GS:ESI+28],EAX
        add     ESI,32
        loop    @@NextDataBlock

;  ⪨ ?
@@ShortDataBlock:
        cmp     DX,0
        je      @@NoShortBlock
; ନ஢ ਯ  ⪮ 
        mov     EAX,ESI
        add     EAX,32
        mov     [GS:ESI],EAX
        ;  ࠢ
        mov     EAX,[ShDevType] ;⨯ ன⢠
        or      EAX,00800000h   ;ਧ ⨢
        mov     [GS:ESI+4],EAX
        ; થ
        mov     EAX,[ShFuncNum] ; 㭪樨
        dec     DX
        shl     EDX,21
        or      EAX,EDX         ;ࠧ 
        or      EAX,EDI         ;ਣ 
        or      EAX,69h
        mov     [GS:ESI+8],EAX
        mov     [GS:ESI+12],EBX
        xor     EAX,EAX
        mov     [GS:ESI+16],EAX
        mov     [GS:ESI+20],EAX
        mov     [GS:ESI+24],EAX
        mov     [GS:ESI+28],EAX
        add     ESI,32

@@NoShortBlock:
; ନ஢ ਯ ⮣ 
        mov     [dword ptr GS:ESI],1b ;᫥ TD
        ;  ࠢ
        mov     EAX,[ShDevType] ;⨯ ன⢠
        or      EAX,00800000h   ;ਧ ⨢
        mov     [GS:ESI+4],EAX
        ; થ
        mov     EAX,[ShFuncNum] ; 㭪樨
        or      EAX,0FFE800E1h  ;। ⮩ 
        mov     [GS:ESI+8],EAX
        xor     EAX,EAX
        mov     [GS:ESI+12],EAX
        mov     [GS:ESI+16],EAX
        mov     [GS:ESI+20],EAX
        mov     [GS:ESI+24],EAX
        mov     [GS:ESI+28],EAX
; ⠭ 㪠⥫  ᯨ᮪ ਯ஢
; (஫ 稭 । )
        mov     EAX,[Addr_TD_Array]
        mov     ESI,[Addr_QH]
        add     ESI,4
        mov     [GS:ESI],EAX
;   ⥪饣 
        mov     DX,[USB_BaseAddr]
        add     DX,6
        in      AX,DX
        mov     [StartFrame],AX
;  襭 樨
@@Wait_OpComplete:
        ; ஢  
        in      AX,DX
        sub     AX,[StartFrame]
        and     AX,7FFh   ;뤥 訥 11 ࠧ冷
        cmp     AX,500    ;   500 ஢
        ja      @@TimeOut ;ॢ襭 ࢠ 
        ; ஢ ᫮ ﭨ
        cmp     [dword ptr GS:ESI],1b
        jne     @@Wait_OpComplete
        popad
        ret
; ॢ襭 ⨬ ࢠ 
@@TimeOut:
        ; ⠭ ஫
        mov     DX,[USB_BaseAddr]
        mov     AX,0
        out     DX,AX
        MFatalError TmOut
; ९ ᨢ ਯ஢
@@TD_Array_Error:
        ; ⠭ ஫
        mov     DX,[USB_BaseAddr]
        mov     AX,0
        out     DX,AX
        MFatalError DsErr
ENDP StatusIN_Transaction

;*******************************************************
;*              USB           *
;* । ࠬ:                             *
;* SI - ᬥ饭 ਯ   ᥣ .*
;*******************************************************
PROC Setup_Transaction near
        pushad
; ᫨    ਯ 
        xor     EAX,EAX
        mov     AX,DS
        shl     EAX,4
        and     ESI,0FFFFh
        add     EAX,ESI
        mov     [Addr_CommandDescr],EAX
; 㧨  ESI 㪠⥫  ᨢ ਯ஢
        mov     ESI,[Addr_TD_Array]
; ନ஢ ਯ 
        ; ⥫  ᫥騩 TD
        mov     EAX,ESI
        add     EAX,32
        mov     [GS:ESI],EAX
        ;  ࠢ
        mov     EAX,[ShDevType] ;⨯ ன⢠
        or      EAX,00800000h   ;ਧ ⨢
        mov     [GS:ESI+4],EAX
        ; થ
        mov     EAX,[ShFuncNum] ; 㭪樨
        or      EAX,00E0002Dh   ;। 8 
        mov     [GS:ESI+8],EAX
        ; ⥫  ਯ 
        mov     EAX,[Addr_CommandDescr]
        mov     [GS:ESI+12],EAX
        xor     EAX,EAX
        mov     [GS:ESI+16],EAX
        mov     [GS:ESI+20],EAX
        mov     [GS:ESI+24],EAX
        mov     [GS:ESI+28],EAX
        add     ESI,32

; ନ஢ ਯ  ਥ ⮣ 
        mov     [dword ptr GS:ESI],1b ;᫥ TD
        ;  ࠢ
        mov     EAX,[ShDevType] ;⨯ ன⢠
        or      EAX,00800000h   ;ਧ ⨢
        mov     [GS:ESI+4],EAX
        ; થ
        mov     EAX,[ShFuncNum] ; 㭪樨
        or      EAX,0FFE80069h  ;ਭ ⮩ 
        mov     [GS:ESI+8],EAX
        xor     EAX,EAX
        mov     [GS:ESI+12],EAX
        mov     [GS:ESI+16],EAX
        mov     [GS:ESI+20],EAX
        mov     [GS:ESI+24],EAX
        mov     [GS:ESI+28],EAX
; ⠭ 㪠⥫  ᯨ᮪ ਯ஢
; (஫ 稭 । )
        mov     EAX,[Addr_TD_Array]
        mov     ESI,[Addr_QH]
        add     ESI,4
        mov     [GS:ESI],EAX
;   ⥪饣 
        mov     DX,[USB_BaseAddr]
        add     DX,6
        in      AX,DX
        mov     [StartFrame],AX
;  襭 樨
@@Wait_OpComplete:
        ; ஢  
        in      AX,DX
        sub     AX,[StartFrame]
        and     AX,7FFh   ;뤥 訥 11 ࠧ冷
        cmp     AX,500    ;   500 ஢
        ja      @@TimeOut ;ॢ襭 ࢠ 
        ; ஢ ᫮ ﭨ
        cmp     [dword ptr GS:ESI],1b
        jne     @@Wait_OpComplete
        popad
        ret
; ॢ襭 ⨬ ࢠ 
@@TimeOut:
        ; ⠭ ஫
        mov     DX,[USB_BaseAddr]
        mov     AX,0
        out     DX,AX
        MFatalError TmOut
ENDP Setup_Transaction

;****************************************************
;*      *
;* । ࠬ:                          *
;* USB_PortReg -  ॣ ;              *
;* USB_Device_Number - 浪  ன⢠. *
;****************************************************
PROC Enumeration near
        pushad
; ஢ 
        mov     DX,[USB_PortReg]
        mov     AX,1110b
        out     DX,AX
; ।   ⨯ ன⢠
        mov     DX,[USB_PortReg]
        in      AX,DX
        test    AX,100000000b
        jnz     @@Low
        mov     [dword ptr ShDevType],0
        jmp short @@DeviceTypeSaved
@@Low:  mov     [dword ptr ShDevType],4000000h
@@DeviceTypeSaved:

; ᫥  ன⢮  㫥 
        mov     [dword ptr ShFuncNum],0
; ᫨ 浪 
        inc     [USB_Device_Number]
;   "Set Address"
        xor     AX,AX
        mov     AL,[USB_Device_Number]
        mov     [word ptr SetAddrDesc+2],AX
        mov     SI,offset SetAddrDesc
        call    Setup_Transaction
; ᢮ ன 浪 
        xor     EAX,EAX
        mov     AL,[USB_Device_Number]
        shl     EAX,8
        mov     [ShFuncNum],EAX
        popad
        ret
ENDP Enumeration

;************************************
;*    *
;************************************
PROC GetConfigurationDescriptor near
        pusha
;   "Get Configuration Descriptor"
        mov     SI,offset GetConfDesc
        call    StatusIN_Transaction
;   ࠧ 㯯 ਯ஢
; 䨣樨
        mov     AX,[word ptr DataBuffer+2]
        mov     [word ptr GetConfDesc+6],AX
;   "Get Configuration Descriptor"
        mov     SI,offset GetConfDesc
        call    StatusIN_Transaction
        popa
        ret
ENDP GetConfigurationDescriptor
ENDS
