;                      8.3
;   客   㩭 ਭ
;           EPSON Stylus  䥩ᮬ USB
;
;  ⥪ ணࠬ 㫠  쥢.
;  list8_03.asm, 17.06.2002.

IDEAL
P386
LOCALS
MODEL MEDIUM

; ᪨     ᯨ᪠ ஢ USB
FrameListBaseAddr equ 200000h

;  䠩 ᪨ 祭
;  ࠢ   梥⮢ 
include "list1_03.inc"
;  䠩 ᮢ
include "list1_04.inc"

DATASEG
; ⮢ ᮮ饭
Txt0 DB LIGHTMAGENTA,0,22
     DB "    EPSON",0
     DB YELLOW,11,19
     DB " ਭ, ⠭  㬠 ",0
     DB YELLOW,12,13,"ਥ ⮪   "
     DB "   .",0
Txt1 DB LIGHTGREEN,11,0,"䨪 ਭ:",0
     DB YELLOW,24,9,"    "
     DB "   襭 ",0
; 饭  訡
NoPrn DB 12,22,"㩭 ਭ EPSON  㦥",0
PrnEr DB 12,27,"ਭ  ⮢  ࠡ",0
;  ⠥ ப ࠦ
PrintingString    DW ?
;  ⠥ 
PrintingByte      DW ?

;   
;   "Packet Mode"
ExitPacketMode DB 1Bh,0,0,0,1Bh,1
               DB "@EJL 1284.4",0Ah,"@EJL     ",0Ah
;   "Remote Mode"
TerminateRemoteMode DB 4, 1Bh,0,0,0
; 樠஢ ਭ
PrnInitialization   DB 2, 1Bh,'@'
; ⠭ ᪨ ०
SelectGraphicsMode  DB 6, 1Bh,'(','G',1,0,1
; 롮 ஬ ०
MonochromeSelection DB 7, 1Bh,'(','K',1,0,0,1
;  ஢ 䨪 (320 祪  ப)
PrintRasterData     DB 8, 1Bh,'.',0,10,10,1,64,1
; ॢ ப
SetRelVertPosition  DB 7, 1Bh,'(','v',2,0,1,0

;  
; ਯ  "Get Device Descriptor"
GetDevDesc    DB 80h,6
              DW 100h,0,8
; ਯ  "Set Address"
SetAddrDesc   DB 0,5
              DW 1,0,0
; ਯ  "Get Configuration Descriptor"
GetConfDesc   DB 80h,6
              DW 200h,0,8
; ਯ  "Set Configuration"
SetConfigur   DB 00h,9
              DW 1,0,0
; ਯ  "Get Port Status"
GetPortStatus DB 0A1h,1
              DW 0,0,1
; ਯ  "Get Device ID"
GetDeviceID   DB 0A1h,0
              DW 0,0,8
ENDS

;    ࠭ ਯ஢ ।
SEGMENT USB_DESCR para public 'DATA'  
;  । ਯ஢
QH_Descriptor DD  00000003h   ;⢥ 
              DD  00000000h   ;㪠⥫   TD
              DD  0,0,0,0,0,0 ;  
; ᮪ ਯ஢   ࠭樨
TD_Array      DD  8*64 DUP(?)
ENDS

SEGMENT sseg para stack 'STACK'
DB 400h DUP(?)
ENDS

CODESEG
;*****************************
;* ᭮  ணࠬ *
;*****************************
PROC USB_EpsonStylus_Test 
        mov     AX,DGROUP
        mov     DS,AX
        mov     [CS:MainDataSeg],AX
; ⠭ ⥪⮢ ०   ࠭
        mov     AX,3
        int     10h
;   -    ࠭ ࠭
        mov     [ScreenString],25
        mov     [ScreenColumn],0
        call    SetCursorPosition
; ஢ 稥 PCI BIOS
        mov     AX,0B101h
        int     1Ah
        jc      @@PCIBIOSNotFound
        cmp     EDX,20494350h
        jne     @@PCIBIOSNotFound
; 뢥 ⥪⮢ ᮮ饭  ࠭
        MShowColorText 3,Txt0
        call    GetChar
; ⠭ ० אַ 樨 
        call    Initialization
; 樠஢ ਯ USB
        call    InitializeDeascriptors

;   -
        mov     [SearchResult],0
        mov     [USB_HostIndex],0
@@NextHost:
;  ஫ USB
        call    FindUSBController
        cmp     [SearchResult],0
        jne     @@NoHost
; ந   ஫
        mov     DX,[USB_BaseAddr]
        mov     AX,100b       ;⠭ ᨣ 
        out     DX,AX
;    10 
        call    Wait05s
;  ᨣ 
        mov     AX,0
        out     DX,AX
;    10 
        call    Wait05s
; 㫨 稪 ஢
        mov     [USB_Device_Number],0
; 㧨 㪠⥫  ᯨ᮪ ஢  ॣ
;  ᯨ᪠ ஢
        mov     DX,[USB_BaseAddr]
        add     DX,6
        mov     AX,0
        out     DX,AX
        add     DX,2
        mov     EAX,FrameListBaseAddr
        out     DX,EAX
; ⨢஢ -஫
        mov     DX,[USB_BaseAddr]
        mov     AX,1
        out     DX,AX
; ஢ ॣ ﭨ  1
        mov     [USB_PortNum],1
        ; ᫨  ॣ ﭨ 
        mov     DX,[USB_BaseAddr]
        add     DX,10h
        ;   ॣ ﭨ 
        mov     [USB_PortReg],DX
        ; ஢ 稥 ன⢠
        in      AX,DX
        test    AX,000Fh
        jz      @@TestPort2
        ; ᢮ ன 浪 
        call    Enumeration
        ;  ਯ 䨣樨
        call    GetConfigurationDescriptor
        ; ன⢮  ਭ஬?
        cmp     [word ptr DataBuffer+9+5],0107h
        je      @@PrinterFound
; ஢ ॣ ﭨ  2
@@TestPort2:
        mov     [USB_PortNum],2
        ; ᫨  ॣ ﭨ 
        mov     DX,[USB_BaseAddr]
        add     DX,12h
        ;   ॣ ﭨ 
        mov     [USB_PortReg],DX
        ; ஢ 稥 ன⢠
        in      AX,DX
        test    AX,000Fh
        jz      @@ContrStop
        ; ᢮ ன 浪 
        call    Enumeration
        ;  ਯ 䨣樨
        call    GetConfigurationDescriptor
        ; ன⢮  ਭ஬?
        cmp     [word ptr DataBuffer+9+5],0107h
        je      @@PrinterFound
; ⠭ ஫
@@ContrStop:
        mov     DX,[USB_BaseAddr]
        mov     AX,0
        out     DX,AX
        jmp     @@NextHost
@@PrinterFound:

;  
;   "Set Configuration"
        mov     SI,offset SetConfigur
        call    Setup_Transaction
;   "Get Port Status"
        mov     SI,offset GetPortStatus
        call    StatusIN_Transaction
; ஢ ﭨ ਭ
        cmp     [byte ptr DataBuffer],18h
        jne     @@PrinterError

;  
;   "Get Device ID"
        mov     SI,offset GetDeviceID
        call    StatusIN_Transaction
; ।   ਯ
        mov     AX,[word ptr DataBuffer]
        xchg    AL,AH    ;⠢ 
        mov     [word ptr GetDeviceID+6],AX
;   "Get Device ID" ୮
        mov     SI,offset GetDeviceID
        call    StatusIN_Transaction
; ஢ ⨯ ਭ  䨪
        mov     SI,offset DataBuffer
        mov     CX,[SI]  ;㧨  ப
        xchg    CL,CH    ;⠢ 
        add     SI,2
        cmp     CX,4
        jbe     @@DeviceNotFound
        sub     CX,4
        ;  ᪠ ᫮ "EPSON"
        mov     EAX,"OSPE"
@@SearchEPSO:
        cmp     EAX,[SI]
        je      @@SearchStyl
        inc     SI
        loop    @@SearchEPSO
        jmp     @@DeviceNotFound
        ;  ᪠ ᫮ "Stylus"
        mov     EAX,"lytS"
@@SearchStyl:
        cmp     EAX,[SI]
        je      @@ShowDeviceID
        inc     SI
        loop    @@SearchStyl
        jmp     @@DeviceNotFound
;  祭 ਯ
@@ShowDeviceID:
        call    ClearScreen
        MShowColorString Txt0
        MShowColorText 2,Txt1
        mov     [ScreenString],19
        mov     CX,[word ptr GetDeviceID+6]
        call    Show_Ident
        call    GetChar

;     
;  ਣ 
        mov     [dword ptr DataTrigger],0
;   "Packet Mode"
        mov     SI,offset ExitPacketMode
        call    OutCommandToPrn
; 樠஢ ਭ
        mov     SI,offset PrnInitialization
        call    OutCommandToPrn
;  ᪨ ० 
        mov     SI,offset SelectGraphicsMode
        call    OutCommandToPrn
; 롮 ஬ ०
        mov     SI,offset MonochromeSelection
        call    OutCommandToPrn
; ।   ਭ
        call    BulkOUT_Transaction

;   (  )
        ;  稪 ப 
        mov     [PrintingString],0
        ;  砫쭮 祭  客
        mov     DL,80h
@@P0:
;   ப 40  (320/8)
        mov     SI,offset PrintRasterData
        call    OutCommandToPrn
;    ப  
        cmp     [PrintingString],0
        je      @@TopOrBottomLine
        cmp     [PrintingString],319
        jne     @@Shade
@@TopOrBottomLine:
        mov     CX,40
        mov     AL,0FFh ;ᯫ譠 
;   ⠥ ⠬
@@P1:   call    OutCharToPrn
        loop    @@P1
        jmp     @@LF
; 客 
@@Shade:
        ;  ࠭
        mov     AL,DL
        or      AL,80h
        call    OutCharToPrn
        ; ७ 
        mov     CX,38
        mov     AL,DL
@@P2:   call    OutCharToPrn
        loop    @@P2
        ; ࠢ ࠭
        mov     AL,DL
        or      AL,01h
        call    OutCharToPrn
        ;   客 
        rol     DL,1
; ३  ᫥ ப  ਭ
@@LF:   mov     SI,offset SetRelVertPosition
        call    OutCommandToPrn
; ᫠  ਭ   ⪨
        mov     AL,0Dh
        call    OutCharToPrn
; ।   ਭ
        call    BulkOUT_Transaction
; ३  ᫥ ப ࠭ ࠦ
        inc     [PrintingString]
        cmp     [PrintingString],320
        jl      @@P0

; ᫠  ਭ  襭 ࠭
        mov     AL,0Ch ;ॢ ଠ
        call    OutCharToPrn
; 樠஢ ਭ
        mov     SI,offset PrnInitialization
        call    OutCommandToPrn
        call    BulkOUT_Transaction

; ⠭ ஫
        mov     DX,[USB_BaseAddr]
        mov     AX,0
        out     DX,AX
; ⠭ ⥪⮢ ०   ࠭
        mov     AX,3
        int     10h
; 室  DOS
        mov     AH,4Ch
        int     21h

; ࠡ⪠ 訡
@@NoHost:
        cmp     [USB_HostIndex],0
        je      @@HostNotFound
        jmp short @@DeviceNotFound
;  ন PCI BIOS
@@PCIBIOSNotFound:
        MFatalError NoPCI
;   ॣ
@@BadRegisterNumber:
        MFatalError BadRg
;    ஫ USB
@@HostNotFound:
        MFatalError NoUSB
; ன⢮ USB  
@@DeviceNotFound:
        ; ⠭ ஫
        mov     DX,[USB_BaseAddr]
        mov     AX,0
        out     DX,AX
        MFatalError NoPrn
; ਭ  ⮢  
@@PrinterError:
        ; ⠭ ஫
        mov     DX,[USB_BaseAddr]
        mov     AX,0
        out     DX,AX
        MFatalError PrnEr
ENDP USB_EpsonStylus_Test

;***********************************************
;*        USB    *
;* । ࠬ:                     *
;* BULK_DataSize - ꥬ । .  *
;***********************************************
PROC BulkOUT_Transaction near
        pushad
; 㧨  ESI 㪠⥫  ᨢ ਯ஢
        mov     ESI,[Addr_TD_Array]
; 㧨  EBX 㪠⥫   
        mov     EBX,[Addr_DataDescr]
; ᫨ ⢮  (64-) 
        mov     CX,[BULK_DataSize]
        shr     CX,6       ;⢮ 64- 
        cmp     CX,64-1
        ja      @@TD_Array_Error
        cmp     CX,0
        je      @@ShortDataBlock
@@NextDataBlock:
; ନ஢ ਯ 
        ; ⥫  ᫥騩 TD
        mov     EAX,ESI
        add     EAX,32
        mov     [GS:ESI],EAX
        ;  ࠢ
        mov     EAX,[ShDevType] ;⨯ ன⢠
        or      EAX,00800000h   ;ਧ ⨢
        mov     [GS:ESI+4],EAX
        ; થ
        mov     EAX,[ShFuncNum]   ; 㭪樨
        or      EAX,07E000E1h     ;। 64 
        or      EAX,[DataTrigger] ;ਣ 
        or      EAX,00008000h     ;筠 窠 1
        mov     [GS:ESI+8],EAX
        xor     [dword ptr DataTrigger],80000h
        mov     [GS:ESI+12],EBX   ; 
        add     EBX,64
        xor     EAX,EAX
        mov     [GS:ESI+16],EAX
        mov     [GS:ESI+20],EAX
        mov     [GS:ESI+24],EAX
        mov     [GS:ESI+28],EAX
        add     ESI,32
        loop    @@NextDataBlock

; ନ஢  
@@ShortDataBlock:
        ; ᫨ ࠧ ᫥ () 
        mov     DX,[BULK_DataSize]
        and     EDX,111111b
        cmp     DX,0              ;ࠧ  ?
        je      @@NoShortBlock
; ନ஢ ਯ  ⪮ 
        mov     [dword ptr GS:ESI],1b ;᫥ TD
        ;  ࠢ
        mov     EAX,[ShDevType] ;⨯ ன⢠
        or      EAX,00800000h   ;ਧ ⨢
        mov     [GS:ESI+4],EAX
        ; થ
        mov     EAX,[ShFuncNum]   ; 㭪樨
        dec     DX
        shl     EDX,21
        or      EAX,EDX           ;ࠧ 
        or      EAX,[DataTrigger] ;ਣ 
        or      EAX,00008000h     ;筠 窠 1
        or      EAX,0E1h
        mov     [GS:ESI+8],EAX
        xor     [dword ptr DataTrigger],80000h
        mov     [GS:ESI+12],EBX
        xor     EAX,EAX
        mov     [GS:ESI+16],EAX
        mov     [GS:ESI+20],EAX
        mov     [GS:ESI+24],EAX
        mov     [GS:ESI+28],EAX
        jmp short @@Start
;  ⪮ ,  ᫥  
;  
@@NoShortBlock:
        sub     ESI,32
        mov     [dword ptr GS:ESI],1b ;᫥ TD
@@Start:
; ⠭ 㪠⥫  ᯨ᮪ ਯ஢
; (஫ 稭 । )
        mov     EAX,[Addr_TD_Array]
        mov     ESI,[Addr_QH]
        add     ESI,4
        mov     [GS:ESI],EAX
;  襭 樨
@@Wait_OpComplete:
        cmp     [dword ptr GS:ESI],1b
        jne     @@Wait_OpComplete
        mov     [BULK_DataSize],0
        popad
        ret
; ९ ᨢ ਯ஢
@@TD_Array_Error:
        ; ⠭ ஫
        mov     DX,[USB_BaseAddr]
        mov     AX,0
        out     DX,AX
        MFatalError DsErr
ENDP BulkOUT_Transaction

;*****************************
;*     *
;* ࠬ:                *
;* AL -  ᨬ.         *
;*****************************
PROC OutCharToPrn near
        push    BX
        cmp     [BULK_DataSize],4096
        jae     @@Data_Buffer_Full
        mov     BX,offset DataBuffer
        add     BX,[BULK_DataSize]
        mov     [BX],AL
        inc     [BULK_DataSize]
        pop     BX
        ret
; ९  
@@Data_Buffer_Full:
        ; ⠭ ஫
        mov     DX,[USB_BaseAddr]
        mov     AX,0
        out     DX,AX
        MFatalError BfErr
ENDP OutCharToPrn

;******************************************
;*                 *
;* ࠬ:                             *
;* DS:SI - 㪠⥫  ப .   *
;*   ப ᮤন ⢮ *
;* ⮢ , 뫠  ਭ. *
;******************************************
PROC OutCommandToPrn near
        pusha
        cld
; 㧨 稪 ⮢   CX
        lodsb
        xor     CX,CX
        mov     CL,AL
@@OutNextByte:
        lodsb
        call    OutCharToPrn
        loop    @@OutNextByte
        popa
        ret
ENDP OutCommandToPrn

;*************************************************
;*     *
;*************************************************
PROC Show_Ident near
        pusha
        mov     [ScreenString],12
        mov     [ScreenColumn],0
        mov     SI,offset DataBuffer
        mov     CX,[SI]  ;㧨  ப
        xchg    CL,CH    ;⠢ 
        add     SI,2
@@NextByte:
        lodsb
        call    ShowASCIIChar
        loop    @@NextByte
        popa
        ret
ENDP Show_Ident
ENDS

;  楤    뢮  ࠭
;  ⥪⮢ ०
include "list1_02.inc"
;  ணࠬ, ॢ ᥣ
; ॣ GS  ०  樨
include "list2_01.inc"
;  楤  ࠡ  ஫஬ USB
include "list8_01.inc"
END
